
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <string.h>
#include <X11/xv/xvCore.h>
#include <X11/xv/xvFont.h>
#include <X11/xv/xvBasicBitmap.h>
#include <X11/xv/xvLabel.h>
#include <X11/xv/xvBitmap.h>

// ---------------------------------------------

xvBitmap::xvBitmap()
{ 
}

// ---------------------------------------------

xvBitmap::xvBitmap(String name, xvCore & object, Boolean visual, int pixtype)
{
	init(name, object, visual, pixtype);
}

// ---------------------------------------------

xvBitmap::~xvBitmap()
{
}

// ---------------------------------------------

void xvBitmap::init(String name, xvCore & object, Boolean visual, int pixtype)
{
	init(name, object.ID(),visual, pixtype);
}

// ---------------------------------------------

void xvBitmap::init(String name, Widget wid, Boolean visual, int pixtype)
{ 
	int ok=0;
	vis=visual;

	if (visual) {
		xvLabel::init(name, wid);
		xvLabel::SetBorderWidth(1);
		xvLabel::SetLabel(name);
	}
	else
		xvBasicBitmap::init(NULL, wid, pixtype);
}

// ---------------------------------------------

Pixmap xvBitmap::GetPixmap()
{
	if (vis)
		return(xvLabel::bmap.GetPixmap());
	else
		return(xvBasicBitmap::GetPixmap());
}

// ----------------------------------------------
