
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <string.h>

#include <X11/xv/xvCore.h>
#include <X11/xv/xvFontList.h>

// -----------------------------------

xvFontList::xvFontList()
{
	alloc=FALSE;
}

// -----------------------------------

xvFontList::xvFontList(xvCore & object,  String pattern, int numfonts)
{
	init(object, pattern, numfonts);
}

// -----------------------------------

xvFontList::~xvFontList()
{
	if (alloc) {
		XFreeFontNames(fontlist);
		delete fontlist;	
	}
}

// -----------------------------------

void xvFontList::init(xvCore & object,  String pattern, int numfonts)
{
	init(object.ID(), pattern, numfonts);

}

// -----------------------------------

void xvFontList::init(Widget gcw, String pattern, int numfonts)
{
	numreq=numfonts;
	fontlist = new char*[numfonts];
	xvwidget=gcw;
	xvdisplay=XtDisplay(gcw);
	fontlist=XListFonts(xvdisplay, pattern, numfonts, &numret);
	alloc=TRUE;
}

// -----------------------------------

char **xvFontList::GetList()
{
	return(fontlist);
}

// -----------------------------------

int xvFontList::FontsInList()
{
	return(numret);
}

// -----------------------------------
