
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	ObjectList Segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>

// ---------------------------------------------
// local forward function declares


// --------------------------------------------
// Callbacks

void func_objlist(Widget aw, XtPointer client, XtPointer call)
{
	XawListReturnStruct *val=(XawListReturnStruct *) call;
	selected_ref=objectinfo[val->list_index].object_ref;
	strcpy(propeditbuffer, objects[selected_ref].name);
}

void func_objcancel(Widget aw, XtPointer client, XtPointer call)
{
	xvisObjList.RemoveGrab();
	xvisObjList.Close();
}


//---------------------------------------------
// Local Stuff

void buildObjectListWindow(XtCallbackProc execproc)
{
	xvisObjList.init("Object List", "xvisObjList", xvisContext);

	objform.init("objform", xvisObjList);
	objform.SetBackground("gray85");

	objview.init("objview", objform, TRUE, FALSE, TRUE);
	
	objlist.init("objlist", objview, func_objlist, 0, objectlist, 1);
	objlist.SetWidth(200);
	objlist.SetHeight(200);

	objok.init("OK", objform, execproc);
	objok.SetRelVertical(objview);
	objok.SetWidth(60);
	objok.SetHorizDistance(10);

	objcancel.init("Cancel", objform, func_objcancel);
	objcancel.SetRelVertical(objview);
	objcancel.SetWidth(60);
	objcancel.SetHorizDistance(130);	 

}

// ---------------------------------

void openObjectListWindow(objectType listobject, int current)
{
	num_objects=0;
	for (int i=0; i<MAXOBJECTS; i++) {
		if (objects[i].object_type != XVNone) 
			if ((objects[i].object_type == listobject) || (listobject==XVAll)) 
				if (current!=i) {
					sprintf(objectinfo[num_objects].listitem, 
						"%10s %15s", 
						objectName[objects[i].object_type],
						objects[i].name);
					objectinfo[num_objects].object_ref=i;
					objectlist[num_objects]=objectinfo[num_objects].listitem;
					num_objects++;
				}
	}

	if (num_objects==0) 
		objok.SetSensitive(FALSE);
	else
		objok.SetSensitive(TRUE);

	objlist.SetList(num_objects, objectlist);
	objlist.SetWidth(200);
	objlist.SetHeight(200);
	xvisObjList.Open();
	xvisObjList.AddGrab(FALSE, FALSE);
	
}

		